package de.hhu.ba.yoshikoWrapper.gui;

import java.awt.Component;

import javax.swing.JCheckBox;

@SuppressWarnings("serial")
public class ReductionRulesChooser extends ComfortPanel{

	private JCheckBox useCRule;
	private JCheckBox useCCRule;
	private JCheckBox useACRule;
	private JCheckBox useHERule;
	private JCheckBox usePDRRule;
	private JCheckBox useSNRule;
	
	public ReductionRulesChooser() {
		//Initialize subcomponents
		useCRule = new JCheckBox("Use Clique Rule");
		useCCRule = new JCheckBox("Use Critical-Clique Rule");
		useACRule = new JCheckBox("Use Almost-Clique Rule");
		useHERule = new JCheckBox("Use Heavy-Edge 3 in 1 Rule");
		usePDRRule = new JCheckBox("Use Parameter Dependent Reduction Rule");
		useSNRule = new JCheckBox("Use Similar Neighborhood Rule");
		
		this.addAll(
				useCRule,
				useCCRule,
				useACRule,
				useHERule,
				usePDRRule,
				useSNRule
				);
		//By default all reduction rules should be applied
		for (Component c :this.getComponents()) {
			((JCheckBox)c).setSelected(true);
		}
	}
	
	
	/** Creates a 6 Bit bitmask representing the currently selected choice of reduction rules.
	 * @return
	 */
	public String getBitMask() {
		String ret = "";
		ret += (useCRule.isSelected() ? "1" : "0");
		ret += (useCCRule.isSelected() ? "1" : "0");
		ret += (useACRule.isSelected() ? "1" : "0");
		ret += (useHERule.isSelected() ? "1" : "0");
		ret += (usePDRRule.isSelected() ? "1" : "0");
		ret += (useSNRule.isSelected() ? "1" : "0");
		return ret;
	}
}
